package com.io.yutian.colorblindwar.listener;

import com.io.yutian.colorblindwar.ColorblindWar;
import com.io.yutian.colorblindwar.game.Game;
import com.jgxs.yaohun.teleportspigot.api.WarpAPI;
import com.sun.tools.javac.Main;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockExplodeEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.player.*;
import org.bukkit.event.server.ServerListPingEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.Iterator;
public class GameListener implements Listener {

    @EventHandler
    public void onPing(ServerListPingEvent e){
        if (ColorblindWar.getGame().isStarted()) {
            e.setMotd("§a整蛊模式: §6ColorBlockUp  §a当前版本: §6常规版 §b运行中");
        }else{
            e.setMotd("§a整蛊模式: §6ColorBlockUp  §a当前版本: §6常规版 §c未运行");
        }
    }

    /*
    * 当玩家掉出场地后将自动返回出生点
    * */
    @EventHandler
    public void onOffTheField(PlayerMoveEvent e){
        Player p = e.getPlayer();
        Location location = p.getLocation();
        if(location.getY() <= 5){
            Location hubLoc = WarpAPI.get_Spigot_Warps("Spawn");
            p.teleport(hubLoc);
        }
    }

    /*
     * 当发生爆炸时检测被炸方块是否有保护
     * */
    @EventHandler
    public void onBlockExplode(BlockExplodeEvent event) {
        Game game = ColorblindWar.getGame();
        if (game.isStarted()) {
            Iterator<Block> iterator = event.blockList().iterator();
            while (iterator.hasNext()) {
                Block block = iterator.next();
                block.breakNaturally();
                iterator.remove();
            }
        }
    }

    /*
    * 当发生爆炸时检测被炸方块是否有保护
    * */
    @EventHandler
    public void onEntityExplode(EntityExplodeEvent event) {
        Game game = ColorblindWar.getGame();
        if (game.isStarted()) {
            Iterator<Block> iterator = event.blockList().iterator();
            while (iterator.hasNext()) {
                Block block = iterator.next();
                block.breakNaturally();
                iterator.remove();
            }
        }
    }

    /*
    * 拾取任何物品不进入背包直接清理
    * */
    @EventHandler
    public void onPick(PlayerPickupItemEvent e){
        Player p = e.getPlayer();
        p.playSound(p.getLocation(), Sound.ENTITY_ITEM_PICKUP,1,1);
        e.setCancelled(true);
        e.getItem().remove();
    }
}
